﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=2.8
@EndOfDesignText@
'(c) 2022 Peacemaker as updater of the class.
'v.0.3.12
'Class module
Private Sub Class_Globals
	Private fx As JFX
	Private WebCam,ImageIO,BufferedImage,FileIO,Dimension As JavaObject
	Private lstWebCams As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	ImageIO.InitializeStatic("javax.imageio.ImageIO")
	WebCam.InitializeStatic("com.github.sarxos.webcam.Webcam")	
	BufferedImage.InitializeStatic("java.awt.image.BufferedImage")
End Sub

Public Sub getDefaultCam As JavaObject
	WebCam=WebCam.RunMethod("getDefault",Null)
	Return WebCam
End Sub

Public Sub setDimension(cam As JavaObject,width As Int,height As Int)
	cam.RunMethod("setViewSize",Array(Dimension.InitializeNewInstance("java.awt.Dimension",Array(width,height))))	
End Sub

Public Sub OpenCam(cam As JavaObject)
	cam.RunMethod("open",Null)
End Sub

Public Sub TakePicture(cam As JavaObject,filename As String)
	FileIO=	FileIO.InitializeNewInstance("java.io.File",Array(filename))
	BufferedImage=cam.RunMethod("getImage",Null)
	
	ImageIO.RunMethod("write",Array(BufferedImage, "PNG", FileIO))
	
	cam.RunMethod("close",Null)	

End Sub

Public Sub TakePicture2(cam As JavaObject) As Image
	Dim fxutils As JavaObject
	fxutils.initializestatic("javafx.embed.swing.SwingFXUtils")
	Dim im As Image = fxutils.runmethod("toFXImage", Array(cam.RunMethod("getImage", Null), Null))
	Return im
End Sub

Public Sub CloseCam(cam As JavaObject)
	cam.RunMethod("close",Null)
End Sub

Sub getWebcams As List
	Return WebCam.RunMethod("getWebcams",Null)
End Sub

Public Sub WebCam_Names() As List
	lstWebCams = getWebcams
	Dim names As List
	names.Initialize
	For i = 0 To lstWebCams.Size - 1
		Dim newcam As JavaObject = lstWebCams.Get(i)
		Dim name As String = getName(newcam)
		names.Add(name)
	Next
	Return names
End Sub
	
Public Sub getWebcamByName(name As String) As JavaObject
	WebCam = WebCam.RunMethodJO("getWebcamByName", Array As String(name))
	Return WebCam
End Sub

Public Sub getName(cam As JavaObject) As String
	Return cam.RunMethod("getName",Null)
End Sub

