﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private xui As XUI
	Public COLOR_PRESSED As Int
	Public COLOR_BACKGOUND As Int
	Public COLOR_ACCENT As Int
	Public const ABSMAXY As Int = 1000000
	Public const ABSMINY As Int = -1000000
	Public lstPeriods As List = Array As Float (100, 50, 20, 10, 5, 4, 2, 1, 1/60, 1/600, 1/900, 1/1800, 1/3600)	'points per second
	Public lstVisibleIntervals As List = Array As Int (5, 10, 50, 100)	'seconds
	
	Public const STARTMARKER As String = "<sensor>"
	Public const STOPMARKER As String = "</sensor>"
	
	Dim Duration As Long 'длительность эксперимента в секундах
	Dim TimerFormat As Int
	Dim RefreshIndex As Int = 3	'1 Hz
	Dim RefreshInterval As Long	'ms
	Dim AutoRefresh As Boolean = False
	Dim ticker As Long	'current moment of point draw
	
	Dim lstCOMdevices As List
	Dim buffer As Map
	Public MinTimeBetweenRecordsLimit As Long = 20	'milliSec
	Dim isChartsVisible As Boolean
	Dim LastTestPoint As Long
End Sub

#if B4J
Sub RedirectOutput (Dir As String, FileName As String)
   #if RELEASE
   Dim out As OutputStream = File.OpenOutput(Dir, FileName, False) 'Set to True to append the logs
   Dim ps As JavaObject
   ps.InitializeNewInstance("java.io.PrintStream", Array(out, True, "utf8"))
   Dim jo As JavaObject
   jo.InitializeStatic("java.lang.System")
   jo.RunMethod("setOut", Array(ps))
   jo.RunMethod("setErr", Array(ps))
   #end if
End Sub

Sub FullScreen(Frm As Form)
	Dim joForm As JavaObject = Frm
	Dim joStage As JavaObject = joForm.GetField("stage")
	joStage.RunMethod("setMaximized", Array(True))
End Sub

#End If

Sub Save_General_Settings
	StateManager.SetSetting("Duration", Duration)
	StateManager.SetSetting("TimerFormat", TimerFormat)
	StateManager.SetSetting("RefreshIndex", RefreshIndex)
	StateManager.SetSetting("AutoRefresh", AutoRefresh)
	StateManager.SaveSettings
End Sub

Sub Load_General_Settings
	Public COLOR_PRESSED As Int = HexToColor("#ABC7E9")
	Public COLOR_BACKGOUND As Int = HexToColor("#FFE0ECFE")
	Public COLOR_ACCENT As Int = HexToColor("#FFBBD4F2")
	
	Duration = StateManager.GetSetting2("Duration", 60)
	If Duration = 0 Then Duration = 60
	TimerFormat = StateManager.GetSetting2("TimerFormat", 0)
	RefreshIndex = StateManager.GetSetting2("RefreshIndex", 3)
	Calc_Refresh(RefreshIndex)
	AutoRefresh = StateManager.GetSetting2("AutoRefresh", False)
End Sub

Sub Calc_Duration(n As Int, mutiplier As Int)
	If mutiplier = 2 Then mutiplier = 3600
	If mutiplier = 1 Then mutiplier = 60
	If mutiplier = 0 Then mutiplier = 1
	Duration = n * mutiplier
End Sub

Sub Calc_Refresh(n As Int)
	Select n
		Case 0
			RefreshInterval = 0.1 * 1000
		Case 1
			RefreshInterval = 0.2 * 1000
		Case 2
			RefreshInterval = 0.5 * 1000
		Case 3
			RefreshInterval = 1 * 1000
		Case 4
			RefreshInterval = 1 * 60 * 1000
		Case 5
			RefreshInterval = 10 * 60 * 1000
		Case 6
			RefreshInterval = 15 * 60 * 1000
		Case 7
			RefreshInterval = 30 * 60 * 1000
		Case 8
			RefreshInterval = 60 * 60 * 1000
	End Select
	
End Sub

Sub ColorToHex(clr As Int) As String
	Dim bc As ByteConverter
	Return bc.HexFromBytes(bc.IntsToBytes(Array As Int(clr)))
End Sub

Sub HexToColor(InHex As String) As Int
	Dim bc As ByteConverter
	If InHex.StartsWith("#") Then
		InHex = InHex.SubString(1)
	Else If InHex.StartsWith("0x") Then
		InHex = InHex.SubString(2)
	End If

	If InHex.Length = 6 Then
		InHex = "FF" & InHex
	End If

	Dim ints() As Int = bc.IntsFromBytes(bc.HexToBytes(InHex))
	Return ints(0)
End Sub

Sub AddToLog (mapTo As Map, Text As String) As String
	If mapTo = Null Then
		Dim mapTo As Map
	End If
	If mapTo.IsInitialized = False Then
		mapTo.Initialize
	End If
	If mapTo.Size > 0 Then
		If mapTo.GetValueAt(mapTo.Size - 1) = Text Then Return ""
	End If

	Dim b As String, d1, E As Long, f As Float
	DateTime.DateFormat = "dd-MM-yyyy"
	DateTime.TimeFormat = "HH:mm:ss"
	If mapTo.Size > 3000 Then
		mapTo.Remove(mapTo.GetKeyAt(0))	'delete the oldest
	End If

	d1 = DateTime.Now
	E = d1 - DateTime.TimeParse(DateTime.Time(d1))
	f = E/DateTime.TicksPerSecond
	b = NumberFormat2(f, 0, 3, 3, False)
	
	Dim final As String = DateTime.Time(d1) & b & ": " & Text
	mapTo.Put(DateTime.DAte(d1) & " " & DateTime.Time(d1) & b, Text)
	CallSubDelayed2(B4XPages.MainPage, "Show_Logs", final)
	Return final
End Sub


Sub Folder As String
	#if B4J
	Dim res As String = File.DirApp
	#else if B4A
	Dim res As String = DBUtils.GetDBFolder
	#end if
	Return res
End Sub

Public Sub CreateNamedLink(name As String,url As String,color As String) As String
	Return $"[b][u][url="${url}"][color=${color}]${name}[/color][/url][/u][/b]"$
End Sub

Public Sub ContrastColor(Color As Int) As Int
	'From https://stackoverflow.com/a/41335343
	'Counting the perceptive luminance - human eye favors green color...
	'                                        Red                                           Green                                       Blue
	Dim A As Double = 1 - (0.299 * Bit.And(Bit.ShiftRight(Color,16),0xFF) + 0.587 * Bit.And(Bit.ShiftRight(Color,8),0XFF) + 0.114 * Bit.And(Color,0xFF)) / 255
	If A < 0.5 Then
		Return xui.Color_Black
	Else
		Return xui.Color_White
	End If
End Sub


